/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */
 
/* Intro :
 this is a short intro to basic concepts of programming using Processing
 by drawing shapes and manipulate them we will get slowly into different concepts
 such as variables, functions, control structures (conditionals, loops) and finally
 some OOP (Object Oriented Programming) like classes.
 */

/* Processing is constructed over Java, so we could say it is a kind of simplified java.
 setup() and draw() are functions that are defined and called by processing. There are many 
 others and you should check a description of all processing commands in the processing
 website. Check Help > getting started and FAQ for more contextual info about Processing.
 */
 
 /* you should check the processing documentation, this is available locally from the
 Help menu. Check it out as it gives a nice overview to Processing coding environment
 and also provides description of the commands available.
 */
 
/* we will use setup() to set the initial situation and conditions to our program
such as window size, framerate and initialise important variables
*/
void setup() { // this is called just when starting up
  frameRate(20); // set fps
  size(300, 300); // set window size
  noStroke(); // tell processing not to draw outline of shapes. *try to comment this line with //
}

/* draw is our main loop, called X times per second. This depends on the framerate() we set.
 - c1 is a local variable that contains color type of data. Java is a strongly typed programming language.
 variables have to declare the type of the data that will contain
 - Subsecuent drawing functions after fill() wil use this color unless the function is called
 to set a different color. Funtion fill() sets a state of the system
 - random() is a function defined by Processing
 */
void draw(){ 
  background(100); // erase background * try to comment this line with 
  color c1 = color(random(255), random(255), random(255)); // create a random rgb color
  fill(c1); // tell java to use this color as fill color
  ellipse(random(300), random(300), 55, 55); // draw an ellipse at random loc
}
