/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */
 
 /* here we are going to do some action when the circle reaches the limits on top
 of bouncing, we want it to get a new random color.
To change the Processing drawing color we neeed to create a new color and call the
fill() method passing the new color as argument like this
   color c1 =  color(random(255), random(255), random(255));
   fill(c1); 
Because this has to be called from 2 different parts of the code (for the X and for the Y)
 instead or repeating the lines of code in both places we will create a new subroutine
 called changeColor() that we call when we need to change the color
 */

float x = 1;
float y = random(50,150);
float deltaX = random(1,5);
float deltaY = random(1,5);
   
void setup() { // just when starting up
   frameRate(20); // fps
   size(300, 200); // window size
   background(100); // bg color
   noStroke();
   changeColor();
  }
  
  
void changeColor(){
  // this is our won function to set a random fill color
   color c1 =  color(random(255), random(255), random(255));
   fill(c1);
  }

void draw(){ // this is our main loop
    background(100);
    ellipse(x, y, 55, 55);
    x = x+deltaX; // modifies X posotion by deltaX amount
    y = y+deltaY; // modifies Y posotion by deltaY amount
    if (x>=300 || x<=0){ // bounce on right and left
      deltaX = -deltaX; //change X direction
      changeColor(); //
    }
    if (y>=200 || y<=0){ // bounce on top and bottom
      deltaY = -deltaY; //change Y direction
      changeColor();
    }
}
